#define GSM_VARIABLE_BUFFER_LEN (64)
#define GSM_CONVERT_VERSION     (1)

/*
int MOBILEConvertGSM2Latin1(char *GSMString, unsigned char Length, char* Outstring, unsigned char OutBufferLength);
int MOBILEConvertLatin12GSM(char *LatinString, unsigned char Length, char* Outstring, unsigned char OutBufferLength);
*/
//#include "mobile_conv.h"
#include <string.h>
#include <ctype.h>
#include <stdio.h>

int MOBILEConvertGSM2Latin1(const char *GSMString, unsigned char Length, char* Outstring, unsigned char OutMaxBufferLength)
{

    unsigned char maxStringLength = (OutMaxBufferLength - 1);
    memset(Outstring,0,OutMaxBufferLength);
    unsigned char index = 0;
    int buffPos = 0;

    for(index = 0; index < Length; index++)
    {
        if(GSMString[index] == '\\')
        {
            unsigned char c1 = toupper(GSMString[index + 1]);
            unsigned char c2 = toupper(GSMString[index + 2]);

            unsigned char c3 = 0x00;
            unsigned char c4 = 0x00;
            if ( (Length - index) > 4 )
            {
                c3 = toupper(GSMString[index + 3]);
                c4 = toupper(GSMString[index + 4]);
            }
            switch(c1)
            {
                case '0':
                {
                    index +=2;
                    switch(c2)
                    {
                    case '0':
                        Outstring[buffPos++] = (const char)0x40;
                    break;
                    case '1':
                        Outstring[buffPos++] = (const char)0xA3;
                    break;
                    case '2':
                        Outstring[buffPos++] = (const char)0x24;
                    break;
                    case '3':
                        Outstring[buffPos++] = (const char)0xA5;
                    break;
                    case '4':
                        Outstring[buffPos++] = (const char)0xE8;
                    break;
                    case '5':
                        Outstring[buffPos++] = (const char)0xE9;
                    break;
                    case '6':
                        Outstring[buffPos++] = (const char)0xF9;
                    break;
                    case '7':
                        Outstring[buffPos++] = (const char)0xEC;
                    break;
                    case '8':
                        Outstring[buffPos++] = (const char)0xF2;
                    break;
                    case '9':
                        Outstring[buffPos++] = (const char)0xC7;
                    break;
                    case 'A':
                        Outstring[buffPos++] = (const char)0x40;
                    break;
                    case 'B':
                        Outstring[buffPos++] = (const char)0xD8;
                    break;
                    case 'C':
                        Outstring[buffPos++] = (const char)0xF8;
                    break;
                    case 'E':
                        Outstring[buffPos++] = (const char)0xC5;
                    break;
                    case 'F':
                        Outstring[buffPos++] = (const char)0xE5;
                    break;
                    default:
                        // TODO Fehlermeldung erzeugen  
                        index -= 2;
                        Outstring[buffPos++] = GSMString[index];
                    break;
                    }
                }
                break;

                case '1':
                {
                    index += 2;
                    switch(c2)
                    {
                        case '1':
                            Outstring[buffPos++] = 0x5F;
                        break;
                        case 'B':
                        {
                            index +=2;
                            if ( c3 == '0' && c4 == 'A' )
                            {
                                Outstring[buffPos++] = (const char)0x0C;
                            }
                            else if ( c3 == '1' && c4 == '4' )
                            {
                                Outstring[buffPos++] = (const char)0x5E;
                            }
                            else if ( c3 == '2' && c4 == '8' )
                            {
                                Outstring[buffPos++] = (const char)0x7B;
                            }
                            else if ( c3 == '2' && c4 == '9' )
                            {
                                Outstring[buffPos++] = (const char)0x7D;
                            }
                            else if ( c3 == '2' && c4 == 'F' )
                            {
                                Outstring[buffPos++] = (const char)0x5C;
                            }
                            else if ( c3 == '3' && c4 == 'C' )
                            {
                                Outstring[buffPos++] = (const char)0x5B;
                            }
                            else if ( c3 == '3' && c4 == 'D' )
                            {
                                Outstring[buffPos++] = (const char)0x7E;
                            }
                            else if ( c3 == '3' && c4 == 'E' )
                            {
                                Outstring[buffPos++] = (const char)0x5D;
                            }
                            else if ( c3 == '4' && c4 == '0' )
                            {
                                Outstring[buffPos++] = (const char)0x7C;
                            }
                            else
                            {
                                index -= 4;
                                Outstring[buffPos++] = ( GSMString[index] );
                            }
                        }
                        break;
                        case 'C':
                            Outstring[buffPos++] = (const char)0xC6;
                        break;
                        case 'D' :
                            Outstring[buffPos++] = (const char)0xE6 ;
                        break;
                        case 'E' :
                            Outstring[buffPos++] = (const char)0xDF ;
                        break;
                        case 'F' :
                            Outstring[buffPos++] = (const char)0xC9 ;
                        break;
                        default :
                        {
                            index -= 2;
                            Outstring[buffPos++] = GSMString[index];
                        }
                        break;
                    }
                }
                break;
                case '2':
                {
                    if ( c2 == '4' )
                    {
                        Outstring[buffPos++] = (const char)0xA4 ;
                        index += 2;
                    }
                    else
                    {
                        Outstring[buffPos++] = GSMString[index];
                    }
                }
                break;
                case '4':
                {
                    if ( c2 == '0' )
                    {
                        Outstring[buffPos++] = (const char)0xA1;
                        index += 2;
                    }
                    else
                    {
                        Outstring[buffPos++] = (GSMString[index]);
                    }
                }
                break;
                case '5':
                {
                    switch(c2)
                    {
                        case 'B':
                            Outstring[buffPos++] = (const char)0xC4;
                        break;
                        case 'C':
                            Outstring[buffPos++] = (const char)0xD6;
                        break;
                        case 'D':
                            Outstring[buffPos++] = (const char)0xD1;
                        break;
                        case 'E':
                            Outstring[buffPos++] = (const char)0xDC;
                        break;
                        case 'F':
                            Outstring[buffPos++] = (const char)0xA7;
                        break;
                        default:
                            Outstring[buffPos++] = GSMString[index];
                        break;
                    }
                }
                break;
                case '6':
                {
                    if ( c2 == '0' )
                    {
                        Outstring[buffPos++] = (const char)0xBF;
                        index += 2;
                    }
                    else
                    {
                        Outstring[buffPos++] = GSMString[index];
                    }
                }
                break;
                case '7':
                {
                    index += 2;
                    switch(c2)
                    {
                        case 'B':
                            Outstring[buffPos++] = (const char)0xE4;
                        break;
                        case 'C':
                            Outstring[buffPos++] = (const char)0xF6;
                        break;
                        case 'D':
                            Outstring[buffPos++] = (const char)0xF1;
                        break;
                        case 'E':
                            Outstring[buffPos++] = (const char)0xFC;
                        break;
                        case 'F':
                            Outstring[buffPos++] = (const char)0xE0;
                        break;
                        default:
                        index -= 2;
                        Outstring[buffPos++] = GSMString[index];
                        break;
                    }
                }
                break;
                default:
                {
                    Outstring[buffPos++] = ( GSMString[index] );
                }
                break;
            }
        }
        else
        {
            Outstring[buffPos++] = GSMString[index];
        }

        if(buffPos > maxStringLength)
        {
            // wir Haben zu viele Daten 
            buffPos = -1;
            break;
        }
    }
    return buffPos;
}


int MOBILEConvertLatin12GSM(const char *LatinString, unsigned char Length, char* Outstring, unsigned char OutBufferLength)
{
    unsigned char maxStringLength = (OutBufferLength - 1);
    memset(Outstring,0,OutBufferLength);
    unsigned char index = 0;

    for(index = 0; index < Length; index++)
    {
        unsigned char symbol = (unsigned char) LatinString[index];
        switch(symbol)
        {
            case 0x40: // '@'
                strncat(Outstring,"\\00", maxStringLength);
            break;
            case 0xA3: // '£'
                strncat(Outstring, "\\01", maxStringLength); 
            break;
            case 0x24:  // '$'
                strncat(Outstring,"\\02", maxStringLength); 
            break;
            case 0xA5:  // '¥'
                strncat(Outstring,"\\03", maxStringLength); 
            break;
            case 0xE8:  // 'è'
                strncat(Outstring,"\\04", maxStringLength); 
            break;
            case 0xE9: // 'é'
                strncat(Outstring,"\\05", maxStringLength); 
            break;
            case 0xF9: // 'ù' 
                strncat(Outstring,"\\06", maxStringLength); 
            break;
            case 0xEC:  // 'ì'
                strncat(Outstring,"\\07", maxStringLength); 
            break;
            case 0xF2:  // 'ò'
                strncat(Outstring,"\\08", maxStringLength); 
            break;
            case 0xC7:  // 'Ç'
                strncat(Outstring,"\\09", maxStringLength); 
            break;
            case 0xD8:  // 'Ø'
                strncat(Outstring,"\\0B", maxStringLength); 
            break;
            case 0xF8: // 'ø'
                strncat(Outstring,"\\0C", maxStringLength); 
            break;
            case 0xC5: // 'Å'
                strncat(Outstring,"\\0E", maxStringLength); 
            break;
            case 0xE5: // 'å'
                strncat(Outstring,"\\0F", maxStringLength); 
            break;
            case 0x5F: // '_'
                strncat(Outstring,"\\11", maxStringLength); 
            break;
            case 0x0C: // FORM FEED
                strncat(Outstring,"\\1B0A", maxStringLength); 
            break;
            case 0x5E: // '^'
                strncat(Outstring,"\\1B14", maxStringLength); 
            break;
            case 0x7B:  // '{'
                strncat(Outstring,"\\1B28", maxStringLength); 
            break;
            case 0x7D: // '}'
                strncat(Outstring,"\\1B29", maxStringLength); 
            break;
            case 0x5C: // '\' Escape the Backslash
                strncat(Outstring,"\\1B2F", maxStringLength);
            break;
            case 0x5B: 
                strncat(Outstring,"\\1B3C", maxStringLength); 
            break;
            case 0x7E: 
                strncat(Outstring,"\\1B3D", maxStringLength); 
            break;
            case 0x5D: 
                strncat(Outstring,"\\1B3E", maxStringLength); 
            break;
            case 0x7C: 
                strncat(Outstring,"\\1B40", maxStringLength); 
            break;
            case 0xC6: 
                strncat(Outstring,"\\1C", maxStringLength); 
            break;
            case 0xE6: 
                strncat(Outstring,"\\1D", maxStringLength); 
            break;
            case 0xDF: 
                strncat(Outstring,"\\1E", maxStringLength); 
            break;
            case 0xC9: 
                strncat(Outstring,"\\1F", maxStringLength); 
            break;
            case 0xA4: 
                strncat(Outstring,"\\24", maxStringLength); 
            break;
            case 0xA1: 
                strncat(Outstring,"\\40", maxStringLength); 
            break;
            case 0xC4: 
                strncat(Outstring,"\\5B", maxStringLength); 
            break;
            case 0xD6: 
                strncat(Outstring,"\\5C", maxStringLength); 
            break;
            case 0xD1: 
                strncat(Outstring,"\\5D", maxStringLength); 
            break;
            case 0xDC: 
                strncat(Outstring,"\\5E", maxStringLength); 
            break;
            case 0xA7: 
                strncat(Outstring,"\\5F", maxStringLength); 
            break;
            case 0xBF: 
                strncat(Outstring,"\\60", maxStringLength); 
            break;
            case 0xE4: 
                strncat(Outstring,"\\7B", maxStringLength); 
            break;
            case 0xF6:
                strncat(Outstring,"\\7C", maxStringLength); 
            break;
            case 0xF1: 
                strncat(Outstring,"\\7D", maxStringLength); 
            break;
            case 0xFC: 
                strncat(Outstring,"\\7E", maxStringLength); 
            break;
            case 0xE0: 
                strncat(Outstring,"\\7F", maxStringLength); 
            break;
            default: 
                Outstring[strlen(Outstring)] = LatinString[index];
            break;
        }
    }
    return (int)strlen(Outstring);
}


