#include "file/interface/dfitem/dfitem_menu.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemMenu::CDFItemMenu( tinyxml2::XMLDocument *doc ) : CDFItemBase( doc )
{
    xmlElement()->SetText( "ItemMenu" );
}

CDFItemMenu::~CDFItemMenu()
{

}

int CDFItemMenu::Modify( CModifyData &modifyData )
{
    int i;
    unsigned int offs = modifyData.offsFlash, offsChilds;
    CDFItemBase *item;

    // Daten von Bedien einlesen
    StructOperating bedien = *(StructOperating *)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char *)&bedien.ptr );
    offs += sizeof( StructOperating );

    // Daten von BedienMenue einlesen
    StructMenu &menue = *(StructMenu *)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char *)&menue.ptr );

    // Namen aendern?
    strcpy( menue.heading1, LookupReplace( modifyData, menue.heading1 ).c_str() );
    strcpy( menue.heading2, LookupReplace( modifyData, menue.heading2 ).c_str() );

    offs += sizeof( StructMenu );

    // Daten aller Eintraege einlesen
    for ( i = 0; i < (int)menue.numberOfEntries; ++i )
    {
        // Pointer des Eintrags berechnen
        offsChilds = menue.ptr + i * sizeof( unsigned int );

        offsChilds = *(unsigned int *)&modifyData.file->m_flash[offsChilds - FLASH_KONFIG_START];
        ChangeOrderLong( (unsigned char *)&offsChilds );

        item = new CDFItemMenuChoice( xmlElement()->GetDocument() );
        xmlElement()->InsertEndChild( item->xmlElement() );
        modifyData.offsFlash = offsChilds;
        item->Modify( modifyData );
    }

    // Adresse zurueckkonvertieren
    ChangeOrderLong( (unsigned char *)&menue.ptr );

    return 1;
}
